commit 5950a9c5ff3a324d82883983032a32504f4c56fe
Author: Jakub Jelinek <jakub@redhat.com>
Date:   Mon Nov 15 09:30:08 2021

    i386: Fix up x86 atomic_bit_test* expanders for !TARGET_HIMODE_MATH [PR103205]
    
    With !TARGET_HIMODE_MATH, the OPTAB_DIRECT expand_simple_binop fail and so
    we ICE.  We don't really care if they are done promoted in SImode instead.
    
    2021-11-15  Jakub Jelinek  <jakub@redhat.com>
    
            PR target/103205
            * config/i386/sync.md (atomic_bit_test_and_set<mode>,
            atomic_bit_test_and_complement<mode>,
            atomic_bit_test_and_reset<mode>): Use OPTAB_WIDEN instead of
            OPTAB_DIRECT.
    
            * gcc.target/i386/pr103205.c: New test.
    
    (cherry picked from commit 625eef42e32e65b3da0e65e23a706d228896d01c)

diff --git a/gcc/testsuite/gcc.target/i386/pr103205.c b/gcc/testsuite/gcc.target/i386/pr103205.c
new file mode 100644
index 00000000000..eaeea82fee2
--- /dev/null
+++ b/gcc/testsuite/gcc.target/i386/pr103205.c
@@ -0,0 +1,11 @@
+/* PR target/103205 */
+/* { dg-do compile } */
+/* { dg-options "-O2 -mtune-ctrl=^himode_math" } */
+
+unsigned short a;
+
+unsigned short
+foo (void)
+{
+  return __sync_fetch_and_and (&a, ~1) & 1;
+}

